Index: trunk/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj	(revision 2676)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj	(revision 2677)
@@ -57,10 +57,4 @@
       <DependentUpon>BoolDataView.cs</DependentUpon>
     </Compile>
-    <Compile Include="StringConvertibleArrayDataView.cs">
-      <SubType>UserControl</SubType>
-    </Compile>
-    <Compile Include="StringConvertibleArrayDataView.Designer.cs">
-      <DependentUpon>StringConvertibleArrayDataView.cs</DependentUpon>
-    </Compile>
     <Compile Include="StringConvertibleDataView.cs">
       <SubType>UserControl</SubType>
@@ -71,4 +65,10 @@
     <Compile Include="HeuristicLabDataViewsPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="StringConvertibleMatrixDataView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="StringConvertibleMatrixDataView.Designer.cs">
+      <DependentUpon>StringConvertibleMatrixDataView.cs</DependentUpon>
+    </Compile>
   </ItemGroup>
   <ItemGroup>
Index: trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixDataView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixDataView.Designer.cs	(revision 2677)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixDataView.Designer.cs	(revision 2677)
@@ -0,0 +1,151 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Data.Views {
+  partial class StringConvertibleMatrixDataView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing) {
+        if (components != null) components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      this.rowsLabel = new System.Windows.Forms.Label();
+      this.rowsTextBox = new System.Windows.Forms.TextBox();
+      this.dataGridView = new System.Windows.Forms.DataGridView();
+      this.errorProvider = new System.Windows.Forms.ErrorProvider(this.components);
+      this.columnsTextBox = new System.Windows.Forms.TextBox();
+      this.columnsLabel = new System.Windows.Forms.Label();
+      ((System.ComponentModel.ISupportInitialize)(this.dataGridView)).BeginInit();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // rowsLabel
+      // 
+      this.rowsLabel.AutoSize = true;
+      this.rowsLabel.Location = new System.Drawing.Point(3, 3);
+      this.rowsLabel.Name = "rowsLabel";
+      this.rowsLabel.Size = new System.Drawing.Size(37, 13);
+      this.rowsLabel.TabIndex = 0;
+      this.rowsLabel.Text = "&Rows:";
+      // 
+      // rowsTextBox
+      // 
+      this.rowsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.rowsTextBox.Location = new System.Drawing.Point(69, 0);
+      this.rowsTextBox.Name = "rowsTextBox";
+      this.rowsTextBox.Size = new System.Drawing.Size(355, 20);
+      this.rowsTextBox.TabIndex = 1;
+      this.rowsTextBox.Validated += new System.EventHandler(this.rowsTextBox_Validated);
+      this.rowsTextBox.KeyDown += new System.Windows.Forms.KeyEventHandler(this.rowsTextBox_KeyDown);
+      this.rowsTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.rowsTextBox_Validating);
+      // 
+      // dataGridView
+      // 
+      this.dataGridView.AllowUserToAddRows = false;
+      this.dataGridView.AllowUserToDeleteRows = false;
+      this.dataGridView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.dataGridView.ClipboardCopyMode = System.Windows.Forms.DataGridViewClipboardCopyMode.EnableWithoutHeaderText;
+      this.dataGridView.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
+      this.dataGridView.ColumnHeadersVisible = false;
+      this.dataGridView.Location = new System.Drawing.Point(0, 52);
+      this.dataGridView.Name = "dataGridView";
+      this.dataGridView.Size = new System.Drawing.Size(424, 352);
+      this.dataGridView.TabIndex = 4;
+      this.dataGridView.CellParsing += new System.Windows.Forms.DataGridViewCellParsingEventHandler(this.dataGridView_CellParsing);
+      this.dataGridView.CellValidating += new System.Windows.Forms.DataGridViewCellValidatingEventHandler(this.dataGridView_CellValidating);
+      this.dataGridView.CellEndEdit += new System.Windows.Forms.DataGridViewCellEventHandler(this.dataGridView_CellEndEdit);
+      // 
+      // errorProvider
+      // 
+      this.errorProvider.BlinkStyle = System.Windows.Forms.ErrorBlinkStyle.NeverBlink;
+      this.errorProvider.ContainerControl = this;
+      // 
+      // columnsTextBox
+      // 
+      this.columnsTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.columnsTextBox.Location = new System.Drawing.Point(69, 26);
+      this.columnsTextBox.Name = "columnsTextBox";
+      this.columnsTextBox.Size = new System.Drawing.Size(355, 20);
+      this.columnsTextBox.TabIndex = 3;
+      this.columnsTextBox.Validated += new System.EventHandler(this.columnsTextBox_Validated);
+      this.columnsTextBox.KeyDown += new System.Windows.Forms.KeyEventHandler(this.columnsTextBox_KeyDown);
+      this.columnsTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.columnsTextBox_Validating);
+      // 
+      // columnsLabel
+      // 
+      this.columnsLabel.AutoSize = true;
+      this.columnsLabel.Location = new System.Drawing.Point(3, 29);
+      this.columnsLabel.Name = "columnsLabel";
+      this.columnsLabel.Size = new System.Drawing.Size(50, 13);
+      this.columnsLabel.TabIndex = 2;
+      this.columnsLabel.Text = "&Columns:";
+      // 
+      // StringConvertibleMatrixDataView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.dataGridView);
+      this.Controls.Add(this.columnsTextBox);
+      this.Controls.Add(this.rowsTextBox);
+      this.Controls.Add(this.columnsLabel);
+      this.Controls.Add(this.rowsLabel);
+      this.Name = "StringConvertibleMatrixDataView";
+      this.Size = new System.Drawing.Size(424, 404);
+      ((System.ComponentModel.ISupportInitialize)(this.dataGridView)).EndInit();
+      ((System.ComponentModel.ISupportInitialize)(this.errorProvider)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Label rowsLabel;
+    private System.Windows.Forms.TextBox rowsTextBox;
+    private System.Windows.Forms.DataGridView dataGridView;
+    private System.Windows.Forms.ErrorProvider errorProvider;
+    private System.Windows.Forms.TextBox columnsTextBox;
+    private System.Windows.Forms.Label columnsLabel;
+
+  }
+}
Index: trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixDataView.cs
===================================================================
--- trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixDataView.cs	(revision 2677)
+++ trunk/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixDataView.cs	(revision 2677)
@@ -0,0 +1,184 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Data.Views {
+  [Content(typeof(IStringConvertibleMatrixData), true)]
+  public partial class StringConvertibleMatrixDataView : ObjectView {
+    public IStringConvertibleMatrixData StringConvertibleMatrixData {
+      get { return (IStringConvertibleMatrixData)Object; }
+      set { base.Object = value; }
+    }
+
+    public StringConvertibleMatrixDataView() {
+      InitializeComponent();
+      Caption = "StringConvertibleMatrixDataView View";
+      errorProvider.SetIconAlignment(rowsTextBox, ErrorIconAlignment.MiddleLeft);
+      errorProvider.SetIconPadding(rowsTextBox, 2);
+      errorProvider.SetIconAlignment(columnsTextBox, ErrorIconAlignment.MiddleLeft);
+      errorProvider.SetIconPadding(columnsTextBox, 2);
+    }
+    public StringConvertibleMatrixDataView(IStringConvertibleMatrixData stringConvertibleArrayData)
+      : this() {
+      StringConvertibleMatrixData = stringConvertibleArrayData;
+    }
+
+    protected override void DeregisterObjectEvents() {
+      StringConvertibleMatrixData.ItemChanged -= new EventHandler<EventArgs<int, int>>(StringConvertibleMatrixData_ItemChanged);
+      StringConvertibleMatrixData.Reset -= new EventHandler(StringConvertibleMatrixData_Reset);
+      base.DeregisterObjectEvents();
+    }
+
+
+    protected override void RegisterObjectEvents() {
+      base.RegisterObjectEvents();
+      StringConvertibleMatrixData.ItemChanged += new EventHandler<EventArgs<int, int>>(StringConvertibleMatrixData_ItemChanged);
+      StringConvertibleMatrixData.Reset += new EventHandler(StringConvertibleMatrixData_Reset);
+    }
+
+    protected override void OnObjectChanged() {
+      base.OnObjectChanged();
+      if (StringConvertibleMatrixData == null) {
+        Caption = "StringConvertibleMatrixData View";
+        rowsTextBox.Text = "";
+        rowsTextBox.Enabled = false;
+        columnsTextBox.Text = "";
+        columnsTextBox.Enabled = false;
+        dataGridView.Rows.Clear();
+        dataGridView.Columns.Clear();
+        dataGridView.Enabled = false;
+      } else {
+        Caption = "StringConvertibleMatrixData (" + StringConvertibleMatrixData.GetType().Name + ")";
+        UpdateContent();
+      }
+    }
+
+    private void UpdateContent() {
+      rowsTextBox.Text = StringConvertibleMatrixData.Rows.ToString();
+      rowsTextBox.Enabled = (StringConvertibleMatrixData.Dimensions & StringConvertibleArrayDataDimensions.Rows) == StringConvertibleArrayDataDimensions.Rows;
+      columnsTextBox.Text = StringConvertibleMatrixData.Columns.ToString();
+      columnsTextBox.Enabled = (StringConvertibleMatrixData.Dimensions & StringConvertibleArrayDataDimensions.Columns) == StringConvertibleArrayDataDimensions.Columns;
+      dataGridView.Rows.Clear();
+      dataGridView.Columns.Clear();
+      if ((StringConvertibleMatrixData.Rows > 0) && (StringConvertibleMatrixData.Columns > 0)) {
+        for (int i = 0; i < StringConvertibleMatrixData.Columns; i++) {
+          dataGridView.ColumnCount++;
+          dataGridView.Columns[dataGridView.ColumnCount - 1].FillWeight = float.Epsilon;  // sum of all fill weights must not be larger than 65535
+        }
+        dataGridView.RowCount = StringConvertibleMatrixData.Rows;
+        for (int i = 0; i < StringConvertibleMatrixData.Rows; i++) {
+          for (int j = 0; j < StringConvertibleMatrixData.Columns; j++)
+            dataGridView.Rows[i].Cells[j].Value = StringConvertibleMatrixData.GetValue(i, j);
+        }
+        for (int i = 0; i < StringConvertibleMatrixData.Columns; i++)
+          dataGridView.Columns[i].Width = dataGridView.Columns[i].GetPreferredWidth(DataGridViewAutoSizeColumnMode.AllCells, true);
+      }
+      dataGridView.Enabled = true;
+    }
+
+    private void StringConvertibleMatrixData_ItemChanged(object sender, EventArgs<int, int> e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler<EventArgs<int, int>>(StringConvertibleMatrixData_ItemChanged), sender, e);
+      else {
+        dataGridView.Rows[e.Value].Cells[e.Value2].Value = StringConvertibleMatrixData.GetValue(e.Value, e.Value2);
+        Size size = dataGridView.Rows[e.Value].Cells[e.Value2].PreferredSize;
+        dataGridView.Columns[e.Value2].Width = Math.Max(dataGridView.Columns[e.Value2].Width, size.Width);
+      }
+    }
+    private void StringConvertibleMatrixData_Reset(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(StringConvertibleMatrixData_Reset), sender, e);
+      else
+        UpdateContent();
+    }
+
+    #region TextBox Events
+    private void rowsTextBox_Validating(object sender, CancelEventArgs e) {
+      int i = 0;
+      if (!int.TryParse(rowsTextBox.Text, out i) || (i < 0)) {
+        e.Cancel = true;
+        errorProvider.SetError(rowsTextBox, "Invalid Number of Rows");
+        rowsTextBox.SelectAll();
+      }
+    }
+    private void rowsTextBox_Validated(object sender, EventArgs e) {
+      StringConvertibleMatrixData.Rows = int.Parse(rowsTextBox.Text);
+      errorProvider.SetError(rowsTextBox, string.Empty);
+    }
+    private void rowsTextBox_KeyDown(object sender, KeyEventArgs e) {
+      if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return)
+        rowsLabel.Focus();  // set focus on label to validate data
+      if (e.KeyCode == Keys.Escape) {
+        rowsTextBox.Text = StringConvertibleMatrixData.Columns.ToString();
+        rowsLabel.Focus();  // set focus on label to validate data
+      }
+    }
+    private void columnsTextBox_Validating(object sender, CancelEventArgs e) {
+      int i = 0;
+      if (!int.TryParse(columnsTextBox.Text, out i) || (i < 0)) {
+        e.Cancel = true;
+        errorProvider.SetError(columnsTextBox, "Invalid Number of Columns");
+        columnsTextBox.SelectAll();
+      }
+    }
+    private void columnsTextBox_Validated(object sender, EventArgs e) {
+      StringConvertibleMatrixData.Columns = int.Parse(columnsTextBox.Text);
+      errorProvider.SetError(columnsTextBox, string.Empty);
+    }
+    private void columnsTextBox_KeyDown(object sender, KeyEventArgs e) {
+      if (e.KeyCode == Keys.Enter || e.KeyCode == Keys.Return)
+        columnsLabel.Focus();  // set focus on label to validate data
+      if (e.KeyCode == Keys.Escape) {
+        columnsTextBox.Text = StringConvertibleMatrixData.Columns.ToString();
+        columnsLabel.Focus();  // set focus on label to validate data
+      }
+    }
+    #endregion
+
+    #region DataGridView Events
+    private void dataGridView_CellValidating(object sender, DataGridViewCellValidatingEventArgs e) {
+      if (!StringConvertibleMatrixData.Validate(e.FormattedValue.ToString())) {
+        e.Cancel = true;
+        dataGridView.Rows[e.RowIndex].ErrorText = "Invalid Value";
+      }
+    }
+    private void dataGridView_CellParsing(object sender, DataGridViewCellParsingEventArgs e) {
+      string value = e.Value.ToString();
+      e.ParsingApplied = StringConvertibleMatrixData.SetValue(value, e.RowIndex, e.ColumnIndex);
+      if (e.ParsingApplied) e.Value = StringConvertibleMatrixData.GetValue(e.RowIndex, e.ColumnIndex);
+    }
+    private void dataGridView_CellEndEdit(object sender, DataGridViewCellEventArgs e) {
+      dataGridView.Rows[e.RowIndex].ErrorText = string.Empty;
+    }
+    #endregion
+  }
+}
Index: trunk/sources/HeuristicLab.Data/3.3/BoolArrayData.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/BoolArrayData.cs	(revision 2676)
+++ trunk/sources/HeuristicLab.Data/3.3/BoolArrayData.cs	(revision 2677)
@@ -32,9 +32,9 @@
   [Item("BoolArrayData", "Represents an array of boolean values.")]
   [Creatable("Test")]
-  public sealed class BoolArrayData : ValueTypeArrayData<bool>, IStringConvertibleArrayData {
+  public sealed class BoolArrayData : ValueTypeArrayData<bool>, IStringConvertibleMatrixData {
     public BoolArrayData() : base() { }
     public BoolArrayData(int length) : base(length) { }
     public BoolArrayData(bool[] elements) : base(elements) { }
-    protected BoolArrayData(BoolArrayData elements) : base(elements) { }
+    private BoolArrayData(BoolArrayData elements) : base(elements) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -44,20 +44,28 @@
     }
 
-    #region IStringConvertibleArrayData Members
-    int IStringConvertibleArrayData.Length {
+    #region IStringConvertibleMatrixData Members
+    StringConvertibleArrayDataDimensions IStringConvertibleMatrixData.Dimensions {
+      get { return StringConvertibleArrayDataDimensions.Rows; }
+    }
+    int IStringConvertibleMatrixData.Rows {
       get { return Length; }
       set { Length = value; }
     }
-    bool IStringConvertibleArrayData.Validate(string value) {
-      bool b;
-      return bool.TryParse(value, out b);
+    int IStringConvertibleMatrixData.Columns {
+      get { return 1; }
+      set { throw new NotSupportedException("Columns cannot be changed."); }
     }
-    string IStringConvertibleArrayData.GetValue(int index) {
-      return this[index].ToString();
+
+    bool IStringConvertibleMatrixData.Validate(string value) {
+      int i;
+      return int.TryParse(value, out i);
     }
-    bool IStringConvertibleArrayData.SetValue(string value, int index) {
+    string IStringConvertibleMatrixData.GetValue(int rowIndex, int columIndex) {
+      return this[rowIndex].ToString();
+    }
+    bool IStringConvertibleMatrixData.SetValue(string value, int rowIndex, int columnIndex) {
       bool b;
       if (bool.TryParse(value, out b)) {
-        this[index] = b;
+        this[rowIndex] = b;
         return true;
       } else {
@@ -65,9 +73,9 @@
       }
     }
-    event EventHandler<EventArgs<int>> IStringConvertibleArrayData.ItemChanged {
+    event EventHandler<EventArgs<int, int>> IStringConvertibleMatrixData.ItemChanged {
       add { base.ItemChanged += value; }
       remove { base.ItemChanged -= value; }
     }
-    event EventHandler IStringConvertibleArrayData.Reset {
+    event EventHandler IStringConvertibleMatrixData.Reset {
       add { base.Reset += value; }
       remove { base.Reset -= value; }
Index: trunk/sources/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj	(revision 2676)
+++ trunk/sources/HeuristicLab.Data/3.3/HeuristicLab.Data-3.3.csproj	(revision 2677)
@@ -104,5 +104,8 @@
     </Compile>
     <Compile Include="BoolArrayData.cs" />
-    <Compile Include="IStringConvertibleArrayData.cs" />
+    <Compile Include="IntMatrixData.cs" />
+    <Compile Include="ValueTypeMatrixData.cs" />
+    <Compile Include="StringConvertibleMatrixDataDimensions.cs" />
+    <Compile Include="IStringConvertibleMatrixData.cs" />
     <Compile Include="ValueTypeArrayData.cs" />
     <Compile Include="IntArrayData.cs" />
Index: trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleMatrixData.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleMatrixData.cs	(revision 2677)
+++ trunk/sources/HeuristicLab.Data/3.3/IStringConvertibleMatrixData.cs	(revision 2677)
@@ -0,0 +1,42 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Xml;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Data {
+  public interface IStringConvertibleMatrixData {
+    StringConvertibleArrayDataDimensions Dimensions { get; }
+    int Rows { get; set; }
+    int Columns { get; set; }
+
+    bool Validate(string value);
+    string GetValue(int rowIndex, int columnIndex);
+    bool SetValue(string value, int rowIndex, int columnIndex);
+
+    event EventHandler<EventArgs<int, int>> ItemChanged;
+    event EventHandler Reset;
+  }
+}
Index: trunk/sources/HeuristicLab.Data/3.3/IntArrayData.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/IntArrayData.cs	(revision 2676)
+++ trunk/sources/HeuristicLab.Data/3.3/IntArrayData.cs	(revision 2677)
@@ -32,9 +32,9 @@
   [Item("IntArrayData", "Represents an array of integer values.")]
   [Creatable("Test")]
-  public sealed class IntArrayData : ValueTypeArrayData<int>, IStringConvertibleArrayData {
+  public sealed class IntArrayData : ValueTypeArrayData<int>, IStringConvertibleMatrixData {
     public IntArrayData() : base() { }
     public IntArrayData(int length) : base(length) { }
     public IntArrayData(int[] elements) : base(elements) { }
-    protected IntArrayData(IntArrayData elements) : base(elements) { }
+    private IntArrayData(IntArrayData elements) : base(elements) { }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -44,20 +44,28 @@
     }
 
-    #region IStringConvertibleArrayData Members
-    int IStringConvertibleArrayData.Length {
+    #region IStringConvertibleMatrixData Members
+    StringConvertibleArrayDataDimensions IStringConvertibleMatrixData.Dimensions {
+      get { return StringConvertibleArrayDataDimensions.Rows; }
+    }
+    int IStringConvertibleMatrixData.Rows {
       get { return Length; }
       set { Length = value; }
     }
-    bool IStringConvertibleArrayData.Validate(string value) {
+    int IStringConvertibleMatrixData.Columns {
+      get { return 1; }
+      set { throw new NotSupportedException("Columns cannot be changed."); }
+    }
+
+    bool IStringConvertibleMatrixData.Validate(string value) {
       int i;
       return int.TryParse(value, out i);
     }
-    string IStringConvertibleArrayData.GetValue(int index) {
-      return this[index].ToString();
+    string IStringConvertibleMatrixData.GetValue(int rowIndex, int columIndex) {
+      return this[rowIndex].ToString();
     }
-    bool IStringConvertibleArrayData.SetValue(string value, int index) {
+    bool IStringConvertibleMatrixData.SetValue(string value, int rowIndex, int columnIndex) {
       int i;
       if (int.TryParse(value, out i)) {
-        this[index] = i;
+        this[rowIndex] = i;
         return true;
       } else {
@@ -65,9 +73,9 @@
       }
     }
-    event EventHandler<EventArgs<int>> IStringConvertibleArrayData.ItemChanged {
+    event EventHandler<EventArgs<int, int>> IStringConvertibleMatrixData.ItemChanged {
       add { base.ItemChanged += value; }
       remove { base.ItemChanged -= value; }
     }
-    event EventHandler IStringConvertibleArrayData.Reset {
+    event EventHandler IStringConvertibleMatrixData.Reset {
       add { base.Reset += value; }
       remove { base.Reset -= value; }
Index: trunk/sources/HeuristicLab.Data/3.3/IntMatrixData.cs
===================================================================
--- trunk/sources/HeuristicLab.Data/3.3/IntMatrixData.cs	(revision 2676)
+++ trunk/sources/HeuristicLab.Data/3.3/IntMatrixData.cs	(revision 2677)
@@ -24,65 +24,62 @@
 using System.Text;
 using System.Xml;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
-using System.Globalization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Data {
-  /// <summary>
-  /// A two-dimensional matrix of integer values.
-  /// </summary>
   [EmptyStorableClass]
-  public class IntMatrixData : ArrayDataBase {
-    /// <summary>
-    /// Gets or sets the int values of the matrix.
-    /// </summary>
-    /// <remarks>Uses property <see cref="ArrayDataBase.Data"/> of base class <see cref="ArrayDataBase"/>. 
-    /// No own data storage present.</remarks>
-    public new int[,] Data {
-      get { return (int[,])base.Data; }
-      set { base.Data = value; }
+  [Item("IntMatrixData", "Represents a matrix of integer values.")]
+  [Creatable("Test")]
+  public sealed class IntMatrixData : ValueTypeMatrixData<int>, IStringConvertibleMatrixData {
+    public IntMatrixData() : base() { }
+    public IntMatrixData(int rows, int columns) : base(rows, columns) { }
+    public IntMatrixData(int[,] elements) : base(elements) { }
+    private IntMatrixData(IntMatrixData elements) : base(elements) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      IntMatrixData clone = new IntMatrixData(this);
+      cloner.RegisterClonedObject(this, clone);
+      return clone;
     }
 
-    /// <summary>
-    /// Initializes a new instance of <see cref="IntMatrixData"/>.
-    /// </summary>
-    public IntMatrixData() {
-      Data = new int[1, 1];
+    #region IStringConvertibleMatrixData Members
+    StringConvertibleArrayDataDimensions IStringConvertibleMatrixData.Dimensions {
+      get { return StringConvertibleArrayDataDimensions.Both; }
     }
-    /// <summary>
-    /// Initializes a new instance of <see cref="IntMatrixData"/>.
-    /// <note type="caution"> No CopyConstructor! <paramref name="data"/> is not copied!</note>
-    /// </summary>
-    /// <param name="data">The two-dimensional int matrix the instance should represent.</param>
-    public IntMatrixData(int[,] data) {
-      Data = data;
+    int IStringConvertibleMatrixData.Rows {
+      get { return Rows; }
+      set { Rows = value; }
+    }
+    int IStringConvertibleMatrixData.Columns {
+      get { return Columns; }
+      set { Columns = value; }
     }
 
-    /// <summary>
-    /// The string representation of the matrix.
-    /// </summary> 
-    /// <returns>The elements of the matrix as a string, line by line, each element separated by a 
-    /// semicolon and formatted according to the local number format.</returns>
-    public override string ToString() {
-      return ToString(CultureInfo.CurrentCulture.NumberFormat);
+    bool IStringConvertibleMatrixData.Validate(string value) {
+      int i;
+      return int.TryParse(value, out i);
     }
-
-    /// <summary>
-    /// The string representation of the matrix, considering a specified <paramref name="format"/>.
-    /// </summary>
-    /// <param name="format">The <see cref="NumberFormatInfo"/> the int values are formatted accordingly.</param>
-    /// <returns>The elements of the matrix as a string, line by line, each element separated by a 
-    /// semicolon and formatted according to the specified <paramref name="format"/>.</returns>
-    private string ToString(NumberFormatInfo format) {
-      StringBuilder builder = new StringBuilder();
-      for (int i = 0; i < Data.GetLength(0); i++) {
-        for (int j = 0; j < Data.GetLength(1); j++) {
-          builder.Append(";");
-          builder.Append(Data[i, j].ToString(format));
-        }
+    string IStringConvertibleMatrixData.GetValue(int rowIndex, int columIndex) {
+      return this[rowIndex, columIndex].ToString();
+    }
+    bool IStringConvertibleMatrixData.SetValue(string value, int rowIndex, int columnIndex) {
+      int i;
+      if (int.TryParse(value, out i)) {
+        this[rowIndex, columnIndex] = i;
+        return true;
+      } else {
+        return false;
       }
-      if (builder.Length > 0) builder.Remove(0, 1);
-      return builder.ToString();
     }
+    event EventHandler<EventArgs<int, int>> IStringConvertibleMatrixData.ItemChanged {
+      add { base.ItemChanged += value; }
+      remove { base.ItemChanged -= value; }
+    }
+    event EventHandler IStringConvertibleMatrixData.Reset {
+      add { base.Reset += value; }
+      remove { base.Reset -= value; }
+    }
+    #endregion
   }
 }
